﻿; _____________________________________________________________________________
; ¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯
; »»» Project  : PB - WinINET.h 
; »»» Compiler : PureBasic 5.10
; »»» Gopher not implemented by now
; _____________________________________________________________________________
; ¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯¯
; //
; // Internet APIs
; //

; //
; // manifests
; //

#INTERNET_INVALID_PORT_NUMBER =    0 ; use the protocol-specific Default
#INTERNET_DEFAULT_FTP_PORT    =   21 ; Default For FTP servers
#INTERNET_DEFAULT_GOPHER_PORT =   70 ;    "     "  gopher "
#INTERNET_DEFAULT_HTTP_PORT   =   80 ;    "     "  HTTP   "
#INTERNET_DEFAULT_HTTPS_PORT  =  443 ;    "     "  HTTPS  "
#INTERNET_DEFAULT_SOCKS_PORT  = 1080 ; Default For SOCKS firewall servers.
#MAX_CACHE_ENTRY_INFO_SIZE    = 4096

; //
; // maximum field lengths (arbitrary)
; //

#INTERNET_MAX_HOST_NAME_LENGTH   = 256
#INTERNET_MAX_USER_NAME_LENGTH   = 128
#INTERNET_MAX_PASSWORD_LENGTH    = 128
#INTERNET_MAX_PORT_NUMBER_LENGTH = 5           ;// INTERNET_PORT is unsigned short
#INTERNET_MAX_PORT_NUMBER_VALUE  = 65535       ;// maximum unsigned short value
#INTERNET_MAX_PATH_LENGTH        = 2048
#INTERNET_MAX_PROTOCOL_NAME      = "gopher"    ;// longest protocol name
#INTERNET_MAX_URL_LENGTH         = 2083 

; //
; // values returned by InternetQueryOption() With INTERNET_OPTION_KEEP_CONNECTION:
; //

#INTERNET_KEEP_ALIVE_UNKNOWN    = 4-1 ; ((DWORD)-1)
#INTERNET_KEEP_ALIVE_ENABLED    = 1
#INTERNET_KEEP_ALIVE_DISABLED   = 0

; //
; // flags returned by InternetQueryOption() With INTERNET_OPTION_REQUEST_FLAGS
; //

#INTERNET_REQFLAG_FROM_CACHE    = $00000001
#INTERNET_REQFLAG_ASYNC         = $00000002

; //
; // flags common To open functions (Not InternetOpen()):
; //

#INTERNET_FLAG_RELOAD           = $80000000  ;// retrieve the original item

; //
; // flags For InternetOpenUrl():
; //

#INTERNET_FLAG_RAW_DATA          = $40000000  ; //receive the item As raw Data
#INTERNET_FLAG_EXISTING_CONNECT  = $20000000  ; //do Not create new connection object

; //
; // flags For InternetOpen():
; //

#INTERNET_FLAG_ASYNC             = $10000000  ; //this request is asynchronous (where supported)

; //
; // protocol-specific flags:
; //

#INTERNET_FLAG_PASSIVE           = $08000000  ; //used For FTP connections

; //
; // additional cache flags
; //

#INTERNET_FLAG_NO_CACHE_WRITE    = $04000000  ; //don't write this item to the cache
#INTERNET_FLAG_DONT_CACHE        = #INTERNET_FLAG_NO_CACHE_WRITE
#INTERNET_FLAG_MAKE_PERSISTENT   = $02000000  ; //make this item persistent in cache
#INTERNET_FLAG_OFFLINE           = $01000000  ; //use offline semantics

; //
; // additional flags
; //

#INTERNET_FLAG_SECURE            = $00800000  ; //use PCT/SSL If applicable (HTTP)
#INTERNET_FLAG_KEEP_CONNECTION   = $00400000  ; //use keep-alive semantics
#INTERNET_FLAG_NO_AUTO_REDIRECT  = $00200000  ; //don't handle redirections automatically
#INTERNET_FLAG_READ_PREFETCH     = $00100000  ; //do background Read prefetch
#INTERNET_FLAG_NO_COOKIES        = $00080000  ; //no automatic cookie handling
#INTERNET_FLAG_NO_AUTH           = $00040000  ; //no automatic authentication handling

; //
; // Security Ignore Flags, Allow HttpOpenRequest To overide
; //  Secure Channel (SSL/PCT) failures of the following types.
; //

#INTERNET_FLAG_IGNORE_REDIRECT_TO_HTTP   = $00008000 ; //ex: https:; //To http://
#INTERNET_FLAG_IGNORE_REDIRECT_TO_HTTPS  = $00004000 ; //ex: http:; //To https://
#INTERNET_FLAG_IGNORE_CERT_DATE_INVALID  = $00002000 ; //expired X509 Cert.
#INTERNET_FLAG_IGNORE_CERT_CN_INVALID    = $00001000 ; //bad common name in X509 Cert.

;//more caching flags
#INTERNET_FLAG_MUST_CACHE_REQUEST        = $00000010 ; //fails If unable To cache request
#INTERNET_FLAG_RESYNCHRONIZE             = $00000800 ; //asking wininet To update an item If it is newer
#INTERNET_FLAG_HYPERLINK                 = $00000400 ; //asking wininet To
                                                     ; //do hyperlinking semantic which works right For scripts
#INTERNET_FLAG_NO_UI                     = $00000200

; //
; // flags For FTP
; //

#FTP_TRANSFER_TYPE_UNKNOWN      = 0 ; Defaults to FTP_TRANSFER_TYPE_BINARY.
#FTP_TRANSFER_TYPE_ASCII        = 1 ; Type A transfer method. Control and formatting information is converted to local equivalents.
#FTP_TRANSFER_TYPE_BINARY       = 2 ; Type I transfer method. The file is transferred exactly as it exists with no changes.


#INTERNET_FLAG_TRANSFER_ASCII       = #FTP_TRANSFER_TYPE_ASCII
#INTERNET_FLAG_TRANSFER_BINARY      = #FTP_TRANSFER_TYPE_BINARY

; //
; // INTERNET_NO_CALLBACK - If this value is presented As the dwContext parameter
; // then no call-backs will be made For that API
; //

#INTERNET_NO_CALLBACK = 0

; //
; // structures/types
; //

; //
; // INTERNET_SCHEME - enumerated URL scheme type
; //

Enumeration -2
  #INTERNET_SCHEME_PARTIAL  ; Partial URL. 
  #INTERNET_SCHEME_UNKNOWN  ; Unknown URL scheme. 
  #INTERNET_SCHEME_DEFAULT  ; Default URL scheme. 
  #INTERNET_SCHEME_FTP      ; FTP URL scheme (ftp:). 
  #INTERNET_SCHEME_GOPHER   ; Gopher URL scheme (gopher:). only xp and earlier
  #INTERNET_SCHEME_HTTP
  #INTERNET_SCHEME_HTTPS
  #INTERNET_SCHEME_FILE
  #INTERNET_SCHEME_NEWS
  #INTERNET_SCHEME_MAILTO
  #INTERNET_SCHEME_SOCKS
  #INTERNET_SCHEME_JAVASCRIPT
  #INTERNET_SCHEME_VBSCRIPT
  #INTERNET_SCHEME_RES
  #INTERNET_SCHEME_FIRST       = #INTERNET_SCHEME_FTP
  #INTERNET_SCHEME_LAST        = #INTERNET_SCHEME_VBSCRIPT
EndEnumeration

; //
; // INTERNET_ASYNC_RESULT - this Structure is returned To the application via
; // the callback With INTERNET_STATUS_REQUEST_COMPLETE. It is Not sufficient To
; // just Return the result of the async operation. If the API failed then the
; // app cannot call GetLastError() because the thread context will be incorrect.
; // Both the value returned by the async API And any resultant error code are
; // made available. The app need Not check dwError If dwResult indicates that
; // the API succeeded (in this Case dwError will be ERROR_SUCCESS)
; //

Structure INTERNET_ASYNC_RESULT
  dwResult.l
  dwError.l
EndStructure

; //
; // INTERNET_PREFETCH_STATUS -
; //

Structure INTERNET_PREFETCH_STATUS
  dwStatus.l
  dwSize.l
EndStructure

; //
; // INTERNET_PREFETCH_STATUS - dwStatus values
; //

#INTERNET_PREFETCH_PROGRESS  = 0
#INTERNET_PREFETCH_COMPLETE  = 1
#INTERNET_PREFETCH_ABORTED   = 2

; //
; // INTERNET_PROXY_INFO - Structure supplied With INTERNET_OPTION_PROXY To get/
; // set proxy information on a InternetOpen() handle
; //

Structure INTERNET_PROXY_INFO
  dwAccessType.l
  lpszProxy.s
  lpszProxyBypass.s
EndStructure

; //
; // INTERNET_VERSION_INFO - version information returned via
; // InternetQueryOption(..., INTERNET_OPTION_VERSION, ...)
; //
    
Structure INTERNET_VERSION_INFO
  dwMajorVersion.l
  dwMinorVersion.l
EndStructure

; //
; // URL_COMPONENTS - the constituent parts of an URL. Used in InternetCrackUrl()
; // And InternetCreateUrl()
; //
; // For InternetCrackUrl(), If a pointer field And its corresponding length field
; // are both 0 then that component is Not returned; If the pointer field is NULL
; // but the length field is Not zero, then both the pointer And length fields are
; // returned; if both pointer and corresponding length fields are non-zero then
; // the pointer field points To a buffer where the component is copied. The
; // component may be un-escaped, depending on dwFlags
; //
; // For InternetCreateUrl(), the pointer fields should be NULL If the component
; // is Not required. If the corresponding length field is zero then the pointer
; // field is the address of a zero-terminated string. If the length field is Not
; // zero then it is the string length of the corresponding pointer field
; //

; Structure URL_COMPONENTS exists (Unicode=URL_COMPONENTW and ASCII=URL_COMPONENTSA ?)

; //
; // INTERNET_CERTIFICATE_INFO lpBuffer - contains the certificate returned from
; // the server
; //

Structure INTERNET_CERTIFICATE_INFO
  ftExpiry.FILETIME
  ftStart.FILETIME
  lpszSubjectInfo.s
  lpszIssuerInfo.s
  lpszProtocolName.s
  lpszSignatureAlgName.s
  lpszEncryptionAlgName.s
  dwKeySize.l
EndStructure

; //
; // constants For InternetTimeFromSystemTime
; //

#INTERNET_RFC1123_FORMAT   =  0
#INTERNET_RFC1123_BUFSIZE  = 30

; //
; // flags For InternetCrackUrl() And InternetCreateUrl()
; //

#ICU_ESCAPE      = $80000000  ;// (un)escape URL characters
#ICU_USERNAME    = $40000000  ;// use internal username & password

; //
; // flags For InternetCanonicalizeUrl() And InternetCombineUrl()
; //

#ICU_NO_ENCODE          = $20000000  ;// Don't convert unsafe characters to escape sequence
#ICU_DECODE             = $10000000  ;// Convert %XX escape sequences To characters
#ICU_NO_META            = $08000000  ;// Don't convert .. etc. meta path sequences
#ICU_ENCODE_SPACES_ONLY = $04000000  ;// Encode spaces only
#ICU_BROWSER_MODE       = $02000000 ;// Special encode/decode rules For browser

; //
; // access types For InternetOpen()
; //

#INTERNET_OPEN_TYPE_PRECONFIG   = 0  ; // use registry configuration
#INTERNET_OPEN_TYPE_DIRECT      = 1  ; // direct To net
#INTERNET_OPEN_TYPE_PROXY       = 3  ; // via named proxy

#PRE_CONFIG_INTERNET_ACCESS  = #INTERNET_OPEN_TYPE_PRECONFIG
#LOCAL_INTERNET_ACCESS       = #INTERNET_OPEN_TYPE_DIRECT
#GATEWAY_INTERNET_ACCESS     = 2 ;  // Internet via gateway
#CERN_PROXY_INTERNET_ACCESS  = #INTERNET_OPEN_TYPE_PROXY

; //
; // service types For InternetConnect()
; //

#INTERNET_SERVICE_FTP    = 1
#INTERNET_SERVICE_GOPHER = 2
#INTERNET_SERVICE_HTTP   = 3

; //
; // flags For InternetSetOptionEx()
; //

#ISO_GLOBAL      = $00000001  ;// modify option globally
#ISO_REGISTRY    = $00000002  ;// write option To registry (where applicable)

#ISO_VALID_FLAGS = #ISO_GLOBAL|#ISO_REGISTRY

; //
; // options manifests For Internet{Query|Set}Option
; //

#INTERNET_OPTION_CALLBACK                =1
#INTERNET_OPTION_CONNECT_TIMEOUT         =2
#INTERNET_OPTION_CONNECT_RETRIES         =3
#INTERNET_OPTION_CONNECT_BACKOFF         =4
#INTERNET_OPTION_SEND_TIMEOUT            =5
#INTERNET_OPTION_CONTROL_SEND_TIMEOUT    = #INTERNET_OPTION_SEND_TIMEOUT
#INTERNET_OPTION_RECEIVE_TIMEOUT         =6
#INTERNET_OPTION_CONTROL_RECEIVE_TIMEOUT = #INTERNET_OPTION_RECEIVE_TIMEOUT
#INTERNET_OPTION_DATA_SEND_TIMEOUT       =7
#INTERNET_OPTION_DATA_RECEIVE_TIMEOUT    =8
#INTERNET_OPTION_HANDLE_TYPE             =9
#INTERNET_OPTION_CONTEXT_VALUE           =10
#INTERNET_OPTION_LISTEN_TIMEOUT          =11
#INTERNET_OPTION_READ_BUFFER_SIZE        =12
#INTERNET_OPTION_WRITE_BUFFER_SIZE       =13

#INTERNET_OPTION_ASYNC_ID                =15
#INTERNET_OPTION_ASYNC_PRIORITY          =16

#INTERNET_OPTION_PARENT_HANDLE           =21
#INTERNET_OPTION_KEEP_CONNECTION         =22
#INTERNET_OPTION_REQUEST_FLAGS           =23
#INTERNET_OPTION_EXTENDED_ERROR          =24

#INTERNET_OPTION_OFFLINE_MODE            =26
#INTERNET_OPTION_CACHE_STREAM_HANDLE     =27
#INTERNET_OPTION_USERNAME                =28
#INTERNET_OPTION_PASSWORD                =29
#INTERNET_OPTION_ASYNC                   =30
#INTERNET_OPTION_SECURITY_FLAGS          =31
#INTERNET_OPTION_SECURITY_CERTIFICATE_STRUCT    =32
#INTERNET_OPTION_DATAFILE_NAME           =33
#INTERNET_OPTION_URL                     =34
#INTERNET_OPTION_SECURITY_CERTIFICATE    =35
#INTERNET_OPTION_SECURITY_KEY_BITNESS    =36
#INTERNET_OPTION_REFRESH                 =37
#INTERNET_OPTION_PROXY                   =38
#INTERNET_OPTION_SETTINGS_CHANGED        =39
#INTERNET_OPTION_VERSION                 =40
#INTERNET_OPTION_USER_AGENT              =41

#INTERNET_FIRST_OPTION                   = #INTERNET_OPTION_CALLBACK
#INTERNET_LAST_OPTION                    = #INTERNET_OPTION_USER_AGENT

; //
; // values For INTERNET_OPTION_PRIORITY
; //

#INTERNET_PRIORITY_FOREGROUND            =1000

; //
; // handle types
; //

#INTERNET_HANDLE_TYPE_INTERNET           =1
#INTERNET_HANDLE_TYPE_CONNECT_FTP        =2
#INTERNET_HANDLE_TYPE_CONNECT_GOPHER     =3
#INTERNET_HANDLE_TYPE_CONNECT_HTTP       =4
#INTERNET_HANDLE_TYPE_FTP_FIND           =5
#INTERNET_HANDLE_TYPE_FTP_FIND_HTML      =6
#INTERNET_HANDLE_TYPE_FTP_FILE           =7
#INTERNET_HANDLE_TYPE_FTP_FILE_HTML      =8
#INTERNET_HANDLE_TYPE_GOPHER_FIND        =9
#INTERNET_HANDLE_TYPE_GOPHER_FIND_HTML   =10
#INTERNET_HANDLE_TYPE_GOPHER_FILE        =11
#INTERNET_HANDLE_TYPE_GOPHER_FILE_HTML   =12
#INTERNET_HANDLE_TYPE_HTTP_REQUEST       =13

; //
; // values For INTERNET_OPTION_SECURITY_FLAGS
; //

#SECURITY_FLAG_SECURE                    = $00000001 ;// can query only
#SECURITY_FLAG_SSL                       = $00000002
#SECURITY_FLAG_SSL3                      = $00000004
#SECURITY_FLAG_PCT                       = $00000008
#SECURITY_FLAG_PCT4                      = $00000010
#SECURITY_FLAG_IETFSSL4                  = $00000020

#SECURITY_FLAG_40BIT                     = $10000000
#SECURITY_FLAG_128BIT                    = $20000000
#SECURITY_FLAG_56BIT                     = $40000000
#SECURITY_FLAG_UNKNOWNBIT                = $80000000
#SECURITY_FLAG_NORMALBITNESS             = #SECURITY_FLAG_40BIT

#SECURITY_FLAG_IGNORE_CERT_CN_INVALID    = #INTERNET_FLAG_IGNORE_CERT_CN_INVALID
#SECURITY_FLAG_IGNORE_CERT_DATE_INVALID  = #INTERNET_FLAG_IGNORE_CERT_DATE_INVALID
#SECURITY_FLAG_IGNORE_REDIRECT_TO_HTTPS  = #INTERNET_FLAG_IGNORE_REDIRECT_TO_HTTPS
#SECURITY_FLAG_IGNORE_REDIRECT_TO_HTTP   = #INTERNET_FLAG_IGNORE_REDIRECT_TO_HTTP

; //
; // status manifests For Internet status callback
; //

#INTERNET_STATUS_RESOLVING_NAME          =10
#INTERNET_STATUS_NAME_RESOLVED           =11
#INTERNET_STATUS_CONNECTING_TO_SERVER    =20
#INTERNET_STATUS_CONNECTED_TO_SERVER     =21
#INTERNET_STATUS_SENDING_REQUEST         =30
#INTERNET_STATUS_REQUEST_SENT            =31
#INTERNET_STATUS_RECEIVING_RESPONSE      =40
#INTERNET_STATUS_RESPONSE_RECEIVED       =41
#INTERNET_STATUS_CTL_RESPONSE_RECEIVED   =42
#INTERNET_STATUS_PREFETCH                =43
#INTERNET_STATUS_CLOSING_CONNECTION      =50
#INTERNET_STATUS_CONNECTION_CLOSED       =51
#INTERNET_STATUS_HANDLE_CREATED          =60
#INTERNET_STATUS_HANDLE_CLOSING          =70
#INTERNET_STATUS_REQUEST_COMPLETE        =100
#INTERNET_STATUS_REDIRECT                =110
#INTERNET_STATUS_INTERMEDIATE_RESPONSE   =120
#INTERNET_STATUS_STATE_CHANGE            =200

; //
; // If the following value is returned by InternetSetStatusCallback, then
; // probably an invalid (non-code) address was supplied For the callback
; //

;#INTERNET_INVALID_STATUS_CALLBACK =       ((#INTERNET_STATUS_CALLBACK)(-1L))

; //
; // FTP
; //

; //
; // manifests
; //

#FTP_TRANSFER_TYPE_UNKNOWN   = $00000000
#FTP_TRANSFER_TYPE_ASCII     = $00000001
#FTP_TRANSFER_TYPE_BINARY    = $00000002
#FTP_TRANSFER_TYPE_MASK      = #FTP_TRANSFER_TYPE_ASCII|#FTP_TRANSFER_TYPE_BINARY

; --- Gopher not implemented by now

; //
; // HTTP
; //

; //
; // manifests
; //

; //
; // the Default major/minor HTTP version numbers
; //

#HTTP_MAJOR_VERSION     = 1
#HTTP_MINOR_VERSION     = 0

#HTTP_VERSION           = "HTTP/1.0"

; //
; // HttpQueryInfo info levels. Generally, there is one info level
; // For each potential RFC822/HTTP/MIME header that an HTTP server
; // may send As part of a request response.
; //
; // The HTTP_QUERY_RAW_HEADERS info level is provided For clients
; // that choose To perform their own header parsing.
; //

#HTTP_QUERY_MIME_VERSION              = 0 ; Receives the version of the MIME protocol that was used to construct the message.
#HTTP_QUERY_CONTENT_TYPE              = 1 ; Receives the content type of the resource (such as text/html).
#HTTP_QUERY_CONTENT_TRANSFER_ENCODING = 2 ; Receives the additional content coding that has been applied to the resource.
#HTTP_QUERY_CONTENT_ID                = 3 ; Retrieves the content identification.
#HTTP_QUERY_CONTENT_DESCRIPTION       = 4 ; Obsolete. Maintained for legacy application compatibility only.
#HTTP_QUERY_CONTENT_LENGTH            = 5 ; Retrieves the size of the resource, in bytes.
#HTTP_QUERY_CONTENT_LANGUAGE          = 6 ; Retrieves the language that the content is in.
#HTTP_QUERY_ALLOW                     = 7 ; Receives the HTTP verbs supported by the server.
#HTTP_QUERY_PUBLIC                    = 8 ; Receives methods available at this server.
#HTTP_QUERY_DATE                      = 9 ; Receives the date and time at which the message was originated.
#HTTP_QUERY_EXPIRES                   = 10 ; Receives the date and time after which the resource should be considered outdated.
#HTTP_QUERY_LAST_MODIFIED             = 11 ; Receives the date and time at which the server believes the resource was last modified.
#HTTP_QUERY_MESSAGE_ID                = 12 ; No longer supported.
#HTTP_QUERY_URI                       = 13 ; Receives some or all of the Uniform Resource Identifiers (URIs) by which the Request-URI resource can be identified.
#HTTP_QUERY_DERIVED_FROM              = 14 ; No longer supported.
#HTTP_QUERY_COST                      = 15 ; No longer supported.
#HTTP_QUERY_LINK                      = 16 ; Obsolete. Maintained for legacy application compatibility only.
#HTTP_QUERY_PRAGMA                    = 17 ; Receives the implementation-specific directives that might apply to any recipient along the request/response chain.
#HTTP_QUERY_VERSION                   = 18 ; Receives the last response code returned by the server.
#HTTP_QUERY_STATUS_CODE               = 19 ; Receives the status code returned by the server. For more information and a list of possible values, see HTTP Status Codes.
#HTTP_QUERY_STATUS_TEXT               = 20 ; Receives any additional text returned by the server on the response line.
#HTTP_QUERY_RAW_HEADERS               = 21 ; Receives all the headers returned by the server. Each header is terminated by "\0". An additional "\0" terminates the list of headers.
#HTTP_QUERY_RAW_HEADERS_CRLF          = 22 ; Receives all the headers returned by the server. Each header is separated by a carriage return/line feed (CR/LF) sequence.
#HTTP_QUERY_CONNECTION                = 23 ; Retrieves any options that are specified for a particular connection and must not be communicated by proxies over further connections.
#HTTP_QUERY_ACCEPT                    = 24 ; Retrieves the acceptable media types for the response.
#HTTP_QUERY_ACCEPT_CHARSET            = 25 ; Retrieves the acceptable character sets for the response.
#HTTP_QUERY_ACCEPT_ENCODING           = 26 ; Retrieves the acceptable content-coding values for the response.
#HTTP_QUERY_ACCEPT_LANGUAGE           = 27 ; Retrieves the acceptable natural languages for the response.
#HTTP_QUERY_AUTHORIZATION             = 28 ; Retrieves the authorization credentials used for a request.
#HTTP_QUERY_CONTENT_ENCODING          = 29 ; Retrieves any additional content codings that have been applied to the entire resource.
#HTTP_QUERY_FORWARDED                 = 30 ; Obsolete. Maintained for legacy application compatibility only.
#HTTP_QUERY_FROM                      = 31 ; Retrieves the email address for the human user who controls the requesting user agent if the From header is given.
#HTTP_QUERY_IF_MODIFIED_SINCE         = 32 ; Retrieves the contents of the If-Modified-Since header.
#HTTP_QUERY_LOCATION                  = 33 ; Retrieves the absolute Uniform Resource Identifier (URI) used in a Location response-header.
#HTTP_QUERY_ORIG_URI                  = 34 ; Obsolete. Maintained for legacy application compatibility only.
#HTTP_QUERY_REFERER                   = 35 ; Receives the Uniform Resource Identifier (URI) of the resource where the requested URI was obtained.
#HTTP_QUERY_RETRY_AFTER               = 36 ; Retrieves the amount of time the service is expected to be unavailable.
#HTTP_QUERY_SERVER                    = 37 ; Retrieves data about the software used by the origin server to handle the request.
#HTTP_QUERY_TITLE                     = 38 ; Obsolete. Maintained for legacy application compatibility only.
#HTTP_QUERY_USER_AGENT                = 39 ; Retrieves data about the user agent that made the request.
#HTTP_QUERY_WWW_AUTHENTICATE          = 40 ; Retrieves the authentication scheme and realm returned by the server.
#HTTP_QUERY_PROXY_AUTHENTICATE        = 41 ; Retrieves the authentication scheme and realm returned by the proxy.
#HTTP_QUERY_ACCEPT_RANGES             = 42 ; Retrieves the types of range requests that are accepted for a resource.
#HTTP_QUERY_SET_COOKIE                = 43 ; Receives the value of the cookie set for the request.
#HTTP_QUERY_COOKIE                    = 44 ; Retrieves any cookies associated with the request.
#HTTP_QUERY_REQUEST_METHOD            = 45 ; Receives the HTTP verb that is being used in the request, typically GET or POST.
#HTTP_QUERY_REFRESH                   = 46 ; Obsolete. Maintained for legacy application compatibility only.
#HTTP_QUERY_CONTENT_DISPOSITION       = 47 ; Obsolete. Maintained for legacy application compatibility only.
#HTTP_QUERY_AGE                       = 48 ; Retrieves the Age response-header field, which contains the sender's estimate of the amount of time since the response was generated at the origin server.
#HTTP_QUERY_CACHE_CONTROL             = 49 ; Retrieves the cache control directives.
#HTTP_QUERY_CONTENT_BASE              = 50 ; Retrieves the base URI (Uniform Resource Identifier) for resolving relative URLs within the entity.
#HTTP_QUERY_CONTENT_LOCATION          = 51 ; Retrieves the resource location for the entity enclosed in the message.
#HTTP_QUERY_CONTENT_MD5               = 52 ; Retrieves an MD5 digest of the entity-body for the purpose of providing an end-to-end message integrity check (MIC) for the entity-body. For more information, see RFC1864, The Content-MD5 Header Field, at http://ftp.isi.edu/in-notes/rfc1864.txt.
#HTTP_QUERY_CONTENT_RANGE             = 53 ; Retrieves the location in the full entity-body where the partial entity-body should be inserted and the total size of the full entity-body.
#HTTP_QUERY_ETAG                      = 54 ; Retrieves the entity tag for the associated entity.
#HTTP_QUERY_HOST                      = 55 ; Retrieves the Internet host and port number of the resource being requested.
#HTTP_QUERY_IF_MATCH                  = 56 ; Retrieves the contents of the If-Match request-header field.
#HTTP_QUERY_IF_NONE_MATCH             = 57 ; Retrieves the contents of the If-None-Match request-header field.
#HTTP_QUERY_IF_RANGE                  = 58 ; Retrieves the contents of the If-Range request-header field. This header enables the client application to verify that the entity related to a partial copy of the entity in the client application cache has not been updated. If the entity has not been updated, send the parts that the client application is missing. If the entity has been updated, send the entire updated entity.
#HTTP_QUERY_IF_UNMODIFIED_SINCE       = 59 ; Retrieves the contents of the If-Unmodified-Since request-header field.
#HTTP_QUERY_MAX_FORWARDS              = 60 ; Retrieves the number of proxies or gateways that can forward the request to the next inbound server.
#HTTP_QUERY_PROXY_AUTHORIZATION       = 61 ; Retrieves the header that is used to identify the user to a proxy that requires authentication. This header can only be retrieved before the request is sent to the server.
#HTTP_QUERY_RANGE                     = 62 ; Retrieves the byte range of an entity.
#HTTP_QUERY_TRANSFER_ENCODING         = 63 ; Retrieves the type of transformation that has been applied to the message body so it can be safely transferred between the sender and recipient.
#HTTP_QUERY_UPGRADE                   = 64 ; Retrieves the additional communication protocols that are supported by the server.
#HTTP_QUERY_VARY                      = 65 ; Retrieves the header that indicates that the entity was selected from a number of available representations of the response using server-driven negotiation.
#HTTP_QUERY_VIA                       = 66 ; Retrieves the intermediate protocols and recipients between the user agent and the server on requests, and between the origin server and the client on responses.
#HTTP_QUERY_WARNING                   = 67 ; Retrieves additional data about the status of a response that might not be reflected by the response status code.
#HTTP_QUERY_EXPECT                    = 68 ; Retrieves the Expect header, which indicates whether the client application should expect 100 series responses.
#HTTP_QUERY_PROXY_CONNECTION          = 69 ; Retrieves the Proxy-Connection header.
#HTTP_QUERY_UNLESS_MODIFIED_SINCE     = 70 ; Retrieves the Unless-Modified-Since header.
#HTTP_QUERY_ECHO_REQUEST              = 71 ; Not currently implemented.
#HTTP_QUERY_ECHO_REPLY                = 72 ; Not currently implemented.
#HTTP_QUERY_ECHO_HEADERS              = 73 ; Not currently implemented.
#HTTP_QUERY_ECHO_HEADERS_CRLF         = 74 ; Not currently implemented.
#HTTP_QUERY_MAX                       = 78 ; Not a query flag. Indicates the maximum value of an HTTP_QUERY_* value.
#HTTP_QUERY_X_CONTENT_TYPE_OPTIONS    = 79 ; Retrieves the X-Content-Type-Options header value.
#HTTP_QUERY_P3P                       = 80 ; Retrieves the P3P header value.
#HTTP_QUERY_X_P2P_PEERDIST            = 81 ; Retrieves the X-P2P-PeerDist header value.
#HTTP_QUERY_TRANSLATE                 = 82 ; Retrieves the translate header value.
#HTTP_QUERY_X_UA_COMPATIBLE           = 83 ; Retrieves the X-UA-Compatible header value.
#HTTP_QUERY_DEFAULT_STYLE             = 84 ; Retrieves the Default-Style header value.
#HTTP_QUERY_X_FRAME_OPTIONS           = 85 ; Retrieves the X-Frame-Options header value.
#HTTP_QUERY_X_XSS_PROTECTION          = 86 ; Retrieves the X-XSS-Protection header value.
#HTTP_QUERY_CUSTOM                    = 65535 ; Causes HttpQueryInfo to search for the header name specified in lpvBuffer and store the header data in lpvBuffer.
#HTTP_QUERY_FLAG_COALESCE             = $10000000 ; Not implemented.
#HTTP_QUERY_FLAG_NUMBER               = $20000000 ; Returns the data as a 32-bit number for headers whose value is a number, such as the status code.
#HTTP_QUERY_FLAG_SYSTEMTIME           = $40000000 ; Returns the header value as a SYSTEMTIME structure, which does not require the application to parse the data. Use for headers whose value is a date/time string, such as "Last-Modified-Time".
#HTTP_QUERY_FLAG_REQUEST_HEADERS      = $80000000 ; Queries request headers only.

; //
; // HTTP Response Status Codes:
; //

#HTTP_STATUS_CONTINUE           = 100 ; The request can be continued.
#HTTP_STATUS_SWITCH_PROTOCOLS   = 101 ; The server has switched protocols in an upgrade header.
#HTTP_STATUS_OK                 = 200 ; The request completed successfully.
#HTTP_STATUS_CREATED            = 201 ; The request has been fulfilled And resulted in the creation of a new resource.
#HTTP_STATUS_ACCEPTED           = 202 ; The request has been accepted For processing, but the processing has Not been completed.
#HTTP_STATUS_PARTIAL            = 203 ; The returned meta information in the entity-header is Not the definitive set available from the origin server.
#HTTP_STATUS_NO_CONTENT         = 204 ; The server has fulfilled the request, but there is no new information To send back.
#HTTP_STATUS_RESET_CONTENT      = 205 ; The request has been completed, And the client program should reset the document view that caused the request To be sent To allow the user To easily initiate another input action.
#HTTP_STATUS_PARTIAL_CONTENT    = 206 ; The server has fulfilled the partial GET request For the resource.
#HTTP_STATUS_AMBIGUOUS          = 300 ; The server couldn't decide what to return.
#HTTP_STATUS_MOVED              = 301 ; The requested resource has been assigned To a new permanent URI (Uniform Resource Identifier), And any future references To this resource should be done using one of the returned URIs.
#HTTP_STATUS_REDIRECT           = 302 ; The requested resource resides temporarily under a different URI (Uniform Resource Identifier).
#HTTP_STATUS_REDIRECT_METHOD    = 303 ; The response To the request can be found under a different URI (Uniform Resource Identifier) And should be retrieved using a GET HTTP verb on that resource.
#HTTP_STATUS_NOT_MODIFIED       = 304 ; The requested resource has Not been modified.
#HTTP_STATUS_USE_PROXY          = 305 ; The requested resource must be accessed through the proxy given by the location field.
#HTTP_STATUS_REDIRECT_KEEP_VERB = 307 ; The redirected request keeps the same HTTP verb. HTTP/1.1 behavior.
#HTTP_STATUS_BAD_REQUEST        = 400 ; The request could Not be processed by the server due To invalid syntax.
#HTTP_STATUS_DENIED             = 401 ; The requested resource requires user authentication.
#HTTP_STATUS_PAYMENT_REQ        = 402 ; Not currently implemented in the HTTP protocol.
#HTTP_STATUS_FORBIDDEN          = 403 ; The server understood the request, but is refusing To fulfill it.
#HTTP_STATUS_NOT_FOUND          = 404 ; The server has Not found anything matching the requested URI (Uniform Resource Identifier).
#HTTP_STATUS_BAD_METHOD         = 405 ; The HTTP verb used is Not allowed.
#HTTP_STATUS_NONE_ACCEPTABLE    = 406 ; No responses acceptable To the client were found.
#HTTP_STATUS_PROXY_AUTH_REQ     = 407 ; Proxy authentication required.
#HTTP_STATUS_REQUEST_TIMEOUT    = 408 ; The server timed out waiting For the request.
#HTTP_STATUS_CONFLICT           = 409 ; The request could Not be completed due To a conflict With the current state of the resource. The user should resubmit With more information.
#HTTP_STATUS_GONE               = 410 ; The requested resource is no longer available at the server, And no forwarding address is known.
#HTTP_STATUS_LENGTH_REQUIRED    = 411 ; The server refuses To accept the request without a defined content length.
#HTTP_STATUS_PRECOND_FAILED     = 412 ; The precondition given in one Or more of the request header fields evaluated To false when it was tested on the server.
#HTTP_STATUS_REQUEST_TOO_LARGE  = 413 ; The server is refusing To process a request because the request entity is larger than the server is willing Or able To process.
#HTTP_STATUS_URI_TOO_LONG       = 414 ; The server is refusing To service the request because the request URI (Uniform Resource Identifier) is longer than the server is willing To interpret.
#HTTP_STATUS_UNSUPPORTED_MEDIA  = 415 ; The server is refusing To service the request because the entity of the request is in a format Not supported by the requested resource For the requested method.
#HTTP_STATUS_RETRY_WITH         = 449 ; The request should be retried after doing the appropriate action.
#HTTP_STATUS_SERVER_ERROR       = 500 ; The server encountered an unexpected condition that prevented it from fulfilling the request.
#HTTP_STATUS_NOT_SUPPORTED      = 501 ; The server does Not support the functionality required To fulfill the request.
#HTTP_STATUS_BAD_GATEWAY        = 502 ; The server, While acting As a gateway Or proxy, received an invalid response from the upstream server it accessed in attempting To fulfill the request.
#HTTP_STATUS_SERVICE_UNAVAIL    = 503 ; The service is temporarily overloaded.
#HTTP_STATUS_GATEWAY_TIMEOUT    = 504 ; The request was timed out waiting For a gateway.
#HTTP_STATUS_VERSION_NOT_SUP    = 505 ; The server does Not support, Or refuses To support, the HTTP protocol version that was used in the request message.

; //
; // values For dwModifiers parameter of HttpAddRequestHeaders()
; //

#HTTP_ADDREQ_INDEX_MASK      = $0000FFFF
#HTTP_ADDREQ_FLAGS_MASK      = $FFFF0000

; //
; // HTTP_ADDREQ_FLAG_ADD_IF_NEW - the header will only be added If it doesn't
; // already exist
; //

#HTTP_ADDREQ_FLAG_ADD_IF_NEW = $10000000

; //
; // HTTP_ADDREQ_FLAG_ADD - If HTTP_ADDREQ_FLAG_REPLACE is set but the header is
; // Not found then If this flag is set, the header is added anyway, so long As
; // there is a valid header-value
; //

#HTTP_ADDREQ_FLAG_ADD        = $20000000

; //
; // HTTP_ADDREQ_FLAG_COALESCE - coalesce headers With same name. e.g.
; // "Accept: text/*" And "Accept: audio/*" With this flag results in a single
; // header: "Accept: text/*, audio/*"
; //

; //
; // HTTP_ADDREQ_FLAG_COALESCE - coalesce headers With same name. e.g.
; // "Accept: text/*" And "Accept: audio/*" With this flag results in a single
; // header: "Accept: text/*, audio/*"
; //

#HTTP_ADDREQ_FLAG_COALESCE_WITH_COMMA       = $40000000

#HTTP_ADDREQ_FLAG_COALESCE_WITH_SEMICOLON   = $01000000

#HTTP_ADDREQ_FLAG_COALESCE                  = #HTTP_ADDREQ_FLAG_COALESCE_WITH_COMMA

; //
; // HTTP_ADDREQ_FLAG_REPLACE - replaces the specified header. Only one header can
; // be supplied in the buffer. If the header To be replaced is Not the first
; // in a List of headers With the same name, then the relative index should be
; // supplied in the low 8 bits of the dwModifiers parameter. If the header-value
; // part is missing, then the header is removed
; //

#HTTP_ADDREQ_FLAG_REPLACE    = $80000000

; //
; // Internet UI
; //

; //
; // InternetErrorDlg - Provides UI For certain Errors.
; //

#FLAGS_ERROR_UI_FILTER_FOR_ERRORS        = $01
#FLAGS_ERROR_UI_FLAGS_CHANGE_OPTIONS     = $02
#FLAGS_ERROR_UI_FLAGS_GENERATE_DATA      = $04
#FLAGS_ERROR_UI_FLAGS_NO_UI              = $08

; //
; // Internet API error returns
; //

#INTERNET_ERROR_BASE                      = 12000

#ERROR_INTERNET_OUT_OF_HANDLES            = #INTERNET_ERROR_BASE + 1
#ERROR_INTERNET_TIMEOUT                   = #INTERNET_ERROR_BASE + 2
#ERROR_INTERNET_EXTENDED_ERROR            = #INTERNET_ERROR_BASE + 3
#ERROR_INTERNET_INTERNAL_ERROR            = #INTERNET_ERROR_BASE + 4
#ERROR_INTERNET_INVALID_URL               = #INTERNET_ERROR_BASE + 5
#ERROR_INTERNET_UNRECOGNIZED_SCHEME       = #INTERNET_ERROR_BASE + 6
#ERROR_INTERNET_NAME_NOT_RESOLVED         = #INTERNET_ERROR_BASE + 7
#ERROR_INTERNET_PROTOCOL_NOT_FOUND        = #INTERNET_ERROR_BASE + 8
#ERROR_INTERNET_INVALID_OPTION            = #INTERNET_ERROR_BASE + 9
#ERROR_INTERNET_BAD_OPTION_LENGTH         = #INTERNET_ERROR_BASE + 10
#ERROR_INTERNET_OPTION_NOT_SETTABLE       = #INTERNET_ERROR_BASE + 11
#ERROR_INTERNET_SHUTDOWN                  = #INTERNET_ERROR_BASE + 12
#ERROR_INTERNET_INCORRECT_USER_NAME       = #INTERNET_ERROR_BASE + 13
#ERROR_INTERNET_INCORRECT_PASSWORD        = #INTERNET_ERROR_BASE + 14
#ERROR_INTERNET_LOGIN_FAILURE             = #INTERNET_ERROR_BASE + 15
#ERROR_INTERNET_INVALID_OPERATION         = #INTERNET_ERROR_BASE + 16
#ERROR_INTERNET_OPERATION_CANCELLED       = #INTERNET_ERROR_BASE + 17
#ERROR_INTERNET_INCORRECT_HANDLE_TYPE     = #INTERNET_ERROR_BASE + 18
#ERROR_INTERNET_INCORRECT_HANDLE_STATE    = #INTERNET_ERROR_BASE + 19
#ERROR_INTERNET_NOT_PROXY_REQUEST         = #INTERNET_ERROR_BASE + 20
#ERROR_INTERNET_REGISTRY_VALUE_NOT_FOUND  = #INTERNET_ERROR_BASE + 21
#ERROR_INTERNET_BAD_REGISTRY_PARAMETER    = #INTERNET_ERROR_BASE + 22
#ERROR_INTERNET_NO_DIRECT_ACCESS          = #INTERNET_ERROR_BASE + 23
#ERROR_INTERNET_NO_CONTEXT                = #INTERNET_ERROR_BASE + 24
#ERROR_INTERNET_NO_CALLBACK               = #INTERNET_ERROR_BASE + 25
#ERROR_INTERNET_REQUEST_PENDING           = #INTERNET_ERROR_BASE + 26
#ERROR_INTERNET_INCORRECT_FORMAT          = #INTERNET_ERROR_BASE + 27
#ERROR_INTERNET_ITEM_NOT_FOUND            = #INTERNET_ERROR_BASE + 28
#ERROR_INTERNET_CANNOT_CONNECT            = #INTERNET_ERROR_BASE + 29
#ERROR_INTERNET_CONNECTION_ABORTED        = #INTERNET_ERROR_BASE + 30
#ERROR_INTERNET_CONNECTION_RESET          = #INTERNET_ERROR_BASE + 31
#ERROR_INTERNET_FORCE_RETRY               = #INTERNET_ERROR_BASE + 32
#ERROR_INTERNET_INVALID_PROXY_REQUEST     = #INTERNET_ERROR_BASE + 33
#ERROR_INTERNET_NEED_UI                   = #INTERNET_ERROR_BASE + 34

#ERROR_INTERNET_HANDLE_EXISTS             = #INTERNET_ERROR_BASE + 36
#ERROR_INTERNET_SEC_CERT_DATE_INVALID     = #INTERNET_ERROR_BASE + 37
#ERROR_INTERNET_SEC_CERT_CN_INVALID       = #INTERNET_ERROR_BASE + 38
#ERROR_INTERNET_HTTP_TO_HTTPS_ON_REDIR    = #INTERNET_ERROR_BASE + 39
#ERROR_INTERNET_HTTPS_TO_HTTP_ON_REDIR    = #INTERNET_ERROR_BASE + 40
#ERROR_INTERNET_MIXED_SECURITY            = #INTERNET_ERROR_BASE + 41
#ERROR_INTERNET_CHG_POST_IS_NON_SECURE    = #INTERNET_ERROR_BASE + 42
#ERROR_INTERNET_POST_IS_NON_SECURE        = #INTERNET_ERROR_BASE + 43
#ERROR_INTERNET_CLIENT_AUTH_CERT_NEEDED   = #INTERNET_ERROR_BASE + 44
#ERROR_INTERNET_INVALID_CA                = #INTERNET_ERROR_BASE + 45
#ERROR_INTERNET_CLIENT_AUTH_NOT_SETUP     = #INTERNET_ERROR_BASE + 46
#ERROR_INTERNET_ASYNC_THREAD_FAILED       = #INTERNET_ERROR_BASE + 47
#ERROR_INTERNET_REDIRECT_SCHEME_CHANGE    = #INTERNET_ERROR_BASE + 48

; //
; // FTP API errors
; //

#ERROR_FTP_TRANSFER_IN_PROGRESS           = #INTERNET_ERROR_BASE + 110
#ERROR_FTP_DROPPED                        = #INTERNET_ERROR_BASE + 111

; //
; // gopher API errors
; //

#ERROR_GOPHER_PROTOCOL_ERROR              = #INTERNET_ERROR_BASE + 130
#ERROR_GOPHER_NOT_FILE                    = #INTERNET_ERROR_BASE + 131
#ERROR_GOPHER_DATA_ERROR                  = #INTERNET_ERROR_BASE + 132
#ERROR_GOPHER_END_OF_DATA                 = #INTERNET_ERROR_BASE + 133
#ERROR_GOPHER_INVALID_LOCATOR             = #INTERNET_ERROR_BASE + 134
#ERROR_GOPHER_INCORRECT_LOCATOR_TYPE      = #INTERNET_ERROR_BASE + 135
#ERROR_GOPHER_NOT_GOPHER_PLUS             = #INTERNET_ERROR_BASE + 136
#ERROR_GOPHER_ATTRIBUTE_NOT_FOUND         = #INTERNET_ERROR_BASE + 137
#ERROR_GOPHER_UNKNOWN_LOCATOR             = #INTERNET_ERROR_BASE + 138

; //
; // HTTP API errors
; //

#ERROR_HTTP_HEADER_NOT_FOUND              = #INTERNET_ERROR_BASE + 150
#ERROR_HTTP_DOWNLEVEL_SERVER              = #INTERNET_ERROR_BASE + 151
#ERROR_HTTP_INVALID_SERVER_RESPONSE       = #INTERNET_ERROR_BASE + 152
#ERROR_HTTP_INVALID_HEADER                = #INTERNET_ERROR_BASE + 153
#ERROR_HTTP_INVALID_QUERY_REQUEST         = #INTERNET_ERROR_BASE + 154
#ERROR_HTTP_HEADER_ALREADY_EXISTS         = #INTERNET_ERROR_BASE + 155
#ERROR_HTTP_REDIRECT_FAILED               = #INTERNET_ERROR_BASE + 156
#ERROR_HTTP_NOT_REDIRECTED                = #INTERNET_ERROR_BASE + 160 ;// BUGBUG

#ERROR_INTERNET_SECURITY_CHANNEL_ERROR    = #INTERNET_ERROR_BASE + 157 ;// BUGBUG
#ERROR_INTERNET_UNABLE_TO_CACHE_FILE      = #INTERNET_ERROR_BASE + 158 ;// BUGBUG
#ERROR_INTERNET_TCPIP_NOT_INSTALLED       = #INTERNET_ERROR_BASE + 159 ;// BUGBUG

#INTERNET_ERROR_LAST                      = #ERROR_INTERNET_TCPIP_NOT_INSTALLED

; //
; // cache entry type flags.
; //

#NORMAL_CACHE_ENTRY      = $00000001
#STABLE_CACHE_ENTRY      = $00000002
#STICKY_CACHE_ENTRY      = $00000004

#SPARSE_CACHE_ENTRY      = $00010000
#OCX_CACHE_ENTRY         = $00020000

#COOKIE_CACHE_ENTRY      = $00100000
#URLHISTORY_CACHE_ENTRY  = $00200000

; //
; // INTERNET_CACHE_ENTRY_INFO -
; //

; Structure INTERNET_CACHE_ENTRY_INFOA
; Structure INTERNET_CACHE_ENTRY_INFOW

Structure INTERNET_CACHE_ENTRY_INFO
  dwStructSize.l
  lpszSourceUrlName.s
  lpszLocalFileName.s
  CacheEntryType.l
  dwUseCount.l
  dwHitRate.l
  dwSizeLow.l
  dwSizeHigh.l
  LastModifiedTime.FILETIME
  ExpireTime.FILETIME
  LastAccessTime.FILETIME
  LastSyncTime.FILETIME
  *lpHeaderInfo
  dwHeaderInfoSize.l
  lpszFileExtension.s
  StructureUnion
    dwReserved.l
    dwExemptDelta.l
  EndStructureUnion
EndStructure

#CACHE_ENTRY_ATTRIBUTE_FC    = $00000004
#CACHE_ENTRY_HITRATE_FC      = $00000010
#CACHE_ENTRY_MODTIME_FC      = $00000040
#CACHE_ENTRY_EXPTIME_FC      = $00000080
#CACHE_ENTRY_ACCTIME_FC      = $00000100
#CACHE_ENTRY_SYNCTIME_FC     = $00000200
#CACHE_ENTRY_HEADERINFO_FC   = $00000400
; IDE Options = PureBasic 5.10 (Windows - x64)
; CursorPosition = 771
; FirstLine = 716
; Folding = C+
; EnableThread
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 19
; EnableBuildCount = 0